var contador = 0;
var numAcciones = 9;
var gameOver = true;

var World = {

	loaded: false,

	init: function initFn() {
		
		AR.context.services.sensors = false;
		this.createOverlays();
	},

	createOverlays: function createOverlaysFn() {	
		

		// Tracker
		this.tracker = new AR.Tracker("assets/tracker.wtc", {
			onLoaded: this.worldLoaded
		});


		// En construccion
		var imgOne = new AR.ImageResource("assets/enconstruccion.png");
		var overlayOne = new AR.ImageDrawable(imgOne, 0.7, {
			offsetX: -0.15,
			offsetY: 0
		} );

		var pageOne = new AR.Trackable2DObject(this.tracker, "oculto", {
			drawables: {
				cam: overlayOne
			}
		} );

		// Secuencia 4
		var sec4 = new AR.VideoDrawable("assets/secuencia4.mp4", 0.45, {
			onLoaded: this.worldLoaded, 
			offsetX: -0.025,
			offsetY: 0.050
		});

		var trackerSec4 = new AR.Trackable2DObject(this.tracker, "lenador", {
			drawables: {
				cam: [sec4]
			},
			onEnterFieldOfVision: function onEnterFieldOfVisionFn() {
				sec4.play(-1);
			},
			onExitFieldOfVision: function onExitFieldOfVisionFn() {
				sec4.stop();
			},
			enableExtendedTracking:true
		});

		// Secuencia 6
		var sec6 = new AR.VideoDrawable("assets/secuencia6.mp4", 0.5, {
			onLoaded: this.worldLoaded, 
			offsetX: -0.025,
			offsetY: 0.050
		});

		var trackerSec6 = new AR.Trackable2DObject(this.tracker, "batalla", {
			drawables: {
				cam: [sec6]
			},
			onEnterFieldOfVision: function onEnterFieldOfVisionFn() {
				sec6.play(-1);
			},
			onExitFieldOfVision: function onExitFieldOfVisionFn() {
				sec6.stop();
			},
			enableExtendedTracking: true
		});

		// Mensaje
		var mensaje = new AR.VideoDrawable("assets/mensaje.mp4", 0.5, {
			onLoaded: this.worldLoaded, 
			offsetX: 0.025,
			offsetY: 0.050
		});

		var trackerMensaje = new AR.Trackable2DObject(this.tracker, "mensaje", {
			drawables: {
				cam: [mensaje]
			},
			onEnterFieldOfVision: function onEnterFieldOfVisionFn() {
				
				mensaje.play(-1);
			},
			onExitFieldOfVision: function onExitFieldOfVisionFn() {
				mensaje.stop();
			},
			enableExtendedTracking: true
		});

		//Fondo
		var trackerMensaje = new AR.Trackable2DObject(this.tracker, "fondo", {
			drawables: {
				cam: [mensaje]
			},
			onEnterFieldOfVision: function onEnterFieldOfVisionFn() {
				mensaje.play(-1);
			},
			onExitFieldOfVision: function onExitFieldOfVisionFn() {
				mensaje.stop();
			},
			enableExtendedTracking: true
		});

		// Portada
		this.baculo = new AR.Model("assets/baculo.wt3", {

			onLoaded: this.worldLoaded,
		    scale: {
        		x: 0.040,
		        y: 0.040,
		        z: 0.040
		    },
		    translate: {
        		x: 0,
		        y: 1,
		        z: 0
		    },
		    onClick : function( drawable, modelPart ) 
			    {
			    	
			    	var e = document.getElementById('tuto');
					e.parentElement.removeChild(e);

			        switch(modelPart) 
			        {
			            case 'dado': 
			            case 'baston1':
			            case 'bola':


			            World.animParticulas.start(1);
			            World.animRemolino.start(1);
			            World.animDino1.start(1);
				        World.animDino2.start(1);
				        World.animDino3.start(1);
			                
			            break;
			            
			        }
			    }
		});

		var trackerBaculo = new AR.Trackable2DObject(this.tracker, "portada", {
		    drawables: {
		        cam: [this.baculo]
		    },
		    onEnterFieldOfVision: function(){

		    World.animParticulas = new AR.ModelAnimation(World.baculo, "grp_particulas_OK_animation" );			                
				        World.animRemolino = new AR.ModelAnimation(World.baculo, "grp_remolino_todo_animation");
				        World.animDino1 = new AR.ModelAnimation(World.baculo, "hrp_dino_geo_animation" );
				        World.animDino2 = new AR.ModelAnimation(World.baculo, "2_animation" );
				        World.animDino3 = new AR.ModelAnimation(World.baculo, "4_animation" );

			if (World.animParticulas.isRunning()){
			    World.animParticulas.resume();
				World.animRemolino.resume();
				World.animDino1.resume();
				World.animDino2.resume();
				World.animDino3.resume();	
			} else {	    	
		    	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>¡Toca el báculo y alucina con lo que ocurre!</div>";		    	
		    	}
		    },
		    onExitFieldOfVision: function(){
		    		var e = document.getElementById('tuto');
					e.parentElement.removeChild(e);
		    },
			enableExtendedTracking: true
		});

		// Plaza
		var plaza = new AR.Model("assets/plaza.wt3", {

		    onLoaded: this.worldLoaded,
		    scale: {
        		x: 0.040,
		        y: 0.040,
		        z: 0.040
		    }
		});

		var trackerPlaza = new AR.Trackable2DObject(this.tracker, "plaza", {
		    drawables: {
		        cam: [plaza]
		    },
		    onEnterFieldOfVision: function(){
		    	
				World.animPlaza1 = new AR.ModelAnimation(plaza, "1_animation" );
				World.animPlaza2 = new AR.ModelAnimation(plaza, "2_animation" );
				World.animPlazaPeloWigetta = new AR.ModelAnimation(plaza, "joint66_animation" );
				World.animPlaza3 = new AR.ModelAnimation(plaza, "3_animation" );
				World.animPlaza4 = new AR.ModelAnimation(plaza, "4_animation" );
				setTimeout(function() {
									
				                World.animPlaza1.start(-1);
				                World.animPlaza2.start(-1);
				                World.animPlaza3.start(-1);
				                World.animPlaza4.start(-1);
				                World.animPlazaPeloWigetta.start(-1);
							}, 3000);

		    },
		    onExitFieldOfVision: function(){

				
		    },
			enableExtendedTracking: true
		});

		// Laboratorio
		var laboratorio = new AR.Model("assets/laboratorio.wt3", {

		    onLoaded: this.worldLoaded,
		    scale: {
        		x: 0.005,
		        y: 0.005,
		        z: 0.005
		    },
		    rotate: {
        		roll: 180,
		        tilt: 0,
		        heading: 0
		    }
		});

		var trackerLaboratorio = new AR.Trackable2DObject(this.tracker, "laboratorio", {
		    drawables: {
		        cam: [laboratorio]
		    },
		    onEnterFieldOfVision: function() {
				contador++;
				World.animLab1 = new AR.ModelAnimation(laboratorio, "1_animation" );
				World.animLab2 = new AR.ModelAnimation(laboratorio, "grp_laberinto__animation" );
				World.animLab1.start(-1);
				World.animLab2.start(-1);
		    },
		    onExitFieldOfVision: function(){
				
		    },
			enableExtendedTracking: true
		});

		// Enigmatrix
		var puntD1 = 0;
		var respD1 = 2;
		var puntD2 = 0;
		var respD2 = 2;
		var puntD3 = 0;
		var respD3 = 1;

		var preguntaActual = 1;

		var enigmatrix = new AR.Model("assets/enigmatrix.wt3", {

		onLoaded: function (){

				contador ++;
		    	World.animDisco1 = new AR.ModelAnimation(enigmatrix, "grp_disco_1_animation" );
		    	World.animDisco2 = new AR.ModelAnimation(enigmatrix, "grp_disco_2_animation" );
		    	World.animDisco3 = new AR.ModelAnimation(enigmatrix, "grp_disco_3_animation" );
				
			}, 
		    scale: {

		        x: 0.2,
		        y: 0.2,
		        z: 0.2
		    },
		    onClick : function( drawable, modelPart ) 
			    {
			        switch(modelPart) 
			        {
			            case 'disco_1': 

			            puntD1++;
			            World.animDisco1.resume();

						setTimeout(function() {
									
				                World.animDisco1.pause();
							}, 100);
						break;

			            case 'disco_2': 

			            puntD2++;

			            World.animDisco2.resume();
			            setTimeout(function() {
									
				                World.animDisco2.pause();
							}, 100);
						break;

						case 'disco_3': 

						puntD3++;
			            
			            World.animDisco3.resume();
			            setTimeout(function() {
									
				                World.animDisco3.pause();
							}, 100);
						break;
			        }

						if (puntD1==20){							
							puntD1 = 1;
							World.animDisco1.stop();
				    		World.animDisco1.start();
						}
						if (puntD2==17){
							puntD1 = 1;							
							World.animDisco2.stop();
				    		World.animDisco2.start();
						}
						if ((puntD3==20)||(puntD3==10)){

							puntD3 = 1;
							World.animDisco3.stop();
				    		World.animDisco3.start();
						}

			    }
		});

		var imgRotate = new AR.ImageResource("assets/confirmButton.png");

		this.buttonRotate = new AR.ImageDrawable(imgRotate, 0.2, {

			offsetX: 0,
			offsetY: -0.50,
			onClick: function (){

				AR.logger.info("pregunta-> "+preguntaActual);
				AR.logger.info("d1-> "+puntD1+ " d2-> "+puntD2+ " d3-> "+puntD3);
				if (preguntaActual == 1)
				{
					if (puntD1 == respD1) {

						document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO!</div>";

						setTimeout(function() {
							if (!gameOver){
								document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/> En un árbol había siete palomas. Un cazador disparó y mató dos. ¿Cuántas palomas quedan en el árbol?</div>";
								preguntaActual++;
							}
						}, 2000);

					} else {
						document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Los láseres de las paredes se han activado!</div>";

						setTimeout(function() {
							if (!gameOver) {
								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								//reseteamos el juego
						    	World.animDisco1.stop();
						    	World.animDisco1.start();
						    	World.animDisco2.stop();
						    	World.animDisco2.start();
						    	World.animDisco3.stop();
						    	World.animDisco3.start();
						    	puntD1 = 0;
							    puntD2 = 0;
							    puntD3 = 0;
							    preguntaActual = 1;
							    document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/>En medio del libro estoy, no soy ni hoja ni tinta, y si vas a la biblioteca, me encontrarás la primera</div>";
							}
						}, 5000);

					}
				} else {

				if (preguntaActual == 2)
				{
					if (puntD3 == respD3) {

					document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO!</div>";
					setTimeout(function() {
						if (!gameOver){
							document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'> Pregunta: <br/>Si sopla, me muevo. En Pueblo me ves, si miras al cielo. Y corro, pero no vuelo. ¿Qué animal soy?</div>";
							preguntaActual++;
						}
						}, 2000);
					} else {
						document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Los láseres de las paredes se han activado!</div>";
						setTimeout(function() {

							var e = document.getElementById('tuto');
							e.parentElement.removeChild(e);
							//reseteamos el juego
					    	World.animDisco1.stop();
					    	World.animDisco1.start();
					    	World.animDisco2.stop();
					    	World.animDisco2.start();
					    	World.animDisco3.stop();
					    	World.animDisco3.start();
					    	puntD1 = 0;
						    puntD2 = 0;
						    puntD3 = 0;
						    preguntaActual = 1;
						    document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/>En medio del libro estoy, no soy ni hoja ni tinta, y si vas a la biblioteca, me encontrarás la primera</div>";
				
						}, 5000);					}
				} else {

				if (preguntaActual == 3)
				{
					if (puntD2 == respD2||puntD2 == 11) {
						document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡Enhorabuena!¡Has obtenido el libro de claves!</div>";
					} else {
						document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Los láseres de las paredes se han activado!</div>";
					}
						setTimeout(function() {

							var e = document.getElementById('tuto');
							e.parentElement.removeChild(e);
							//reseteamos el juego
					    	World.animDisco1.stop();
					    	World.animDisco1.start();
					    	World.animDisco2.stop();
					    	World.animDisco2.start();
					    	World.animDisco3.stop();
					    	World.animDisco3.start();
					    	puntD1 = 0;
						    puntD2 = 0;
						    puntD3 = 0;
						    preguntaActual = 1;
						    document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/>En medio del libro estoy, no soy ni hoja ni tinta, y si vas a la biblioteca, me encontrarás la primera</div>";
				
						}, 5000);				}
				}
				}
			}
		});

		var trackerEnigmatrix = new AR.Trackable2DObject(this.tracker, "enigmatrix", {
		    drawables: {
		        cam: [enigmatrix, this.buttonRotate]
		    },
		    onEnterFieldOfVision: this.startEnigmatrixGame,
		    onExitFieldOfVision: this.exitEnigmatrixGame,
			enableExtendedTracking: true

		});


		var puebloPregActual = 1;

		// Pueblo
		var pueblo = new AR.Model("assets/pueblo.wt3", {

			onLoaded: this.worldLoaded,
		    scale: {
        		x: 0.025,
		        y: 0.025,
		        z: 0.025
		    },
		    translate: {
        		x: 0.125,
		        y: 0,
		        z: 0
		    },
		    onClick : function( drawable, modelPart ) 
			    {			    	

			        switch(modelPart) 
			        {
			            case 'polySurface87': 

			            if (puebloPregActual == 1) {

			            	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO! ¡Es la casa de Pantricia!</div>";

							setTimeout(function() {
								document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/> A veces, Willy y Vegetta se instalan en este lugar a vigilar y desde abajo parecen gigantes. ¿Cuál es?</div>";
								puebloPregActual++;

							}, 2000);
			            } else {

				            document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Revisa el libro y vuelve a intentarlo!</div>";

							setTimeout(function() {

								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								puebloPregActual = 1;
					
							}, 5000);

			            }
			            break;

			            case 'polySurface110': 
			            case 'polySurface112': 
			            case 'polySurface118': 
						case 'polySurface115': 

			            if (puebloPregActual == 2) {

			            	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO! ¡Es la Torre de Vigilancia!</div>";

							setTimeout(function() {
								document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/> ¿Qué edificio de Pueblo lleva un sombrero transparente?</div>";
								puebloPregActual++;

							}, 2000);
			            } else {

				            document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Revisa el libro y vuelve a intentarlo!</div>";

							setTimeout(function() {

								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								puebloPregActual = 1;
					
							}, 5000);

			            }
			            break;

			            case 'polySurface95':
						case 'polySurface93': 

			            if (puebloPregActual == 3) {

			            	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO! ¡Es la gran biblioteca!</div>";

							setTimeout(function() {
								document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: Si desaparece… ¡¡¡Vacaciones!!!</div>";
								puebloPregActual++;

							}, 2000);
			            } else {

				            document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Revisa el libro y vuelve a intentarlo!</div>";

							setTimeout(function() {

								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								puebloPregActual = 1;
					
							}, 5000);

			            }
			            break;

			            case 'polySurface135':
			            case 'polySurface132':
			            case 'polySurface126': 

			            if (puebloPregActual == 4) {

			            	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡CORRECTO! ¡Es la escuela!</div>";

							setTimeout(function() {
								document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: green'>¡Juego terminado! ¡Disfruta viendo el pueblo!</div>";
								puebloPregActual++;

							}, 2000);
			            } else {

				            document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Revisa el libro y vuelve a intentarlo!</div>";

							setTimeout(function() {

								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								puebloPregActual = 1;
					
							}, 5000);

			            }
			            break;

			            default:
			            	document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info' style='background-color: red'>¡Has fallado!¡Revisa el libro y vuelve a intentarlo!</div>";

							setTimeout(function() {

								var e = document.getElementById('tuto');
								e.parentElement.removeChild(e);
								puebloPregActual = 1;
					
							}, 5000);
			            break;
			        }
			    }
		});

		var trackerPueblo = new AR.Trackable2DObject(this.tracker, "pueblo", {
		    drawables: {
		        cam: [pueblo]
		    },
		    onEnterFieldOfVision: function(){

		    gameOver = false;

		    document.getElementById('tutorialMessage').innerHTML =
					"<div id='tuto' class='info'>Cómo jugar: <br/>"+
					"- Lee la pregunta y piensa la respuesta <br/>"+
					"- Sobre sobre el eficio correcto <br/>";

				setTimeout(function() {

				if (!gameOver) {
					document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/>¿De quién será la casa que tiene un carromato a sus puertas?</div>";
				}
				}, 5000);	

		    },
		    onExitFieldOfVision: function(){

		    		var e = document.getElementById('tuto');
					e.parentElement.removeChild(e);
					puebloPregActual = 1;
					gameOver = true;
		    },
		    enableExtendedTracking: true
		});

	},

	exitEnigmatrixGame: function exitEnigmatrixGameFn() {

		//reseteamos el juego
		World.animDisco1.stop();
	    World.animDisco1.start();
	    World.animDisco2.stop();
	    World.animDisco2.start();
	    World.animDisco3.stop();
	    World.animDisco3.start();			    	
		puntD1 = 0;
	    puntD2 = 0;
	    puntD3 = 0;
	    preguntaActual = 1;
		var e = document.getElementById('tuto');
		e.parentElement.removeChild(e);	
		gameOver = true;
	},

	startEnigmatrixGame: function startEnigmatrixGameFn() {

		gameOver = false;

		document.getElementById('tutorialMessage').innerHTML =
					"<div id='tuto' class='info'>Cómo jugar: <br/>"+
					"- Lee la adivinanza y piensa la respuesta <br/>"+
					"- Mueve los engranajes pulsando sobre ellos <br/>"+
					"- Pulsa el botón rojo para comprobar  </div>";

				setTimeout(function() {

				if (!gameOver){
					document.getElementById('tutorialMessage').innerHTML = "<div id='tuto' class='info'>Pregunta: <br/>En medio del libro estoy, no soy ni hoja ni tinta, y si vas a la biblioteca, me encontrarás la primera</div>";
				}
//					var e = document.getElementById('tuto');
//					e.parentElement.removeChild(e);
				}, 5000);	
	},
	worldLoaded: function worldLoadedFn() {		
		
		contador++;
		if (contador == numAcciones) {

			var cssDivLeft = " style='display: table-cell;vertical-align: middle; text-align: left; padding-left: 15px;'";
			var cssDivRight = " style='display: table-cell;vertical-align: middle; text-align: right;padding-right: 15px;'";
			document.getElementById('loadingMessage').innerHTML =
				"<div" + cssDivLeft + ">Coloca el libro sobre una superficie plana, y luego tu móvil encima de las ilustraciones con este icono</div>" +
				"<div" + cssDivRight + "><img src='assets/ra_icon.png'></img></div>";
							
			setTimeout(function() {
				var e = document.getElementById('loadingMessage');
				e.parentElement.removeChild(e);

				document.getElementById('divClose').innerHTML =
				 '<input type="image" src="img/cancel.png" name="cancel" style="z-index:10000" id="btnCancel" onclick="World.closeWorld();" />'

			}, 5000);
		}

	},
	closeWorld: function closeWorld()
	{		
			AR.context.destroyAll();
			document.location = 'architectsdk://StopAR;'
		
	}


//	,
//	worldLoaded: function worldLoadedFn() {
//
//		AR.logger.info("contador-> "+contador);
//		if (contador==8) {
//
//			var cssDivLeft = " style='display: table-cell;vertical-align: middle; text-align: left; padding-left: 15px;'";
//			var cssDivRight = " style='display: table-cell;vertical-align: middle; text-align: right;padding-right: 15px;'";
//			document.getElementById('loadingMessage').innerHTML =
//				"<div" + cssDivLeft + ">Pon tu móvil encima de las ilustraciones con este icono</div>" +
//				"<div" + cssDivRight + "><img src='assets/ra_icon.png'></img></div>";
//							
//			setTimeout(function() {
//				var e = document.getElementById('loadingMessage');
//				e.parentElement.removeChild(e);
//			}, 5000);
//		}
//	}
};

World.init();

